// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_FONT_PUBLIC_INTERFACES_FONT_SERVICE_MOJOM_BLINK_H_
#define COMPONENTS_SERVICES_FONT_PUBLIC_INTERFACES_FONT_SERVICE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/font/public/interfaces/font_service.mojom-shared.h"
#include "mojo/public/mojom/base/file.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace WTF {
struct font_service_mojom_internal_TypefaceSlant_DataHashFn {
  static unsigned GetHash(const ::font_service::mojom::TypefaceSlant& value) {
    using utype = std::underlying_type<::font_service::mojom::TypefaceSlant>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::font_service::mojom::TypefaceSlant& left, const ::font_service::mojom::TypefaceSlant& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::font_service::mojom::TypefaceSlant> {
  using Hash = font_service_mojom_internal_TypefaceSlant_DataHashFn;
};

template <>
struct HashTraits<::font_service::mojom::TypefaceSlant>
    : public GenericHashTraits<::font_service::mojom::TypefaceSlant> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::font_service::mojom::TypefaceSlant& value) {
    return value == static_cast<::font_service::mojom::TypefaceSlant>(-1000000);
  }
  static void ConstructDeletedValue(::font_service::mojom::TypefaceSlant& slot, bool) {
    slot = static_cast<::font_service::mojom::TypefaceSlant>(-1000001);
  }
  static bool IsDeletedValue(const ::font_service::mojom::TypefaceSlant& value) {
    return value == static_cast<::font_service::mojom::TypefaceSlant>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct font_service_mojom_internal_RenderStyleSwitch_DataHashFn {
  static unsigned GetHash(const ::font_service::mojom::RenderStyleSwitch& value) {
    using utype = std::underlying_type<::font_service::mojom::RenderStyleSwitch>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::font_service::mojom::RenderStyleSwitch& left, const ::font_service::mojom::RenderStyleSwitch& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::font_service::mojom::RenderStyleSwitch> {
  using Hash = font_service_mojom_internal_RenderStyleSwitch_DataHashFn;
};

template <>
struct HashTraits<::font_service::mojom::RenderStyleSwitch>
    : public GenericHashTraits<::font_service::mojom::RenderStyleSwitch> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::font_service::mojom::RenderStyleSwitch& value) {
    return value == static_cast<::font_service::mojom::RenderStyleSwitch>(-1000000);
  }
  static void ConstructDeletedValue(::font_service::mojom::RenderStyleSwitch& slot, bool) {
    slot = static_cast<::font_service::mojom::RenderStyleSwitch>(-1000001);
  }
  static bool IsDeletedValue(const ::font_service::mojom::RenderStyleSwitch& value) {
    return value == static_cast<::font_service::mojom::RenderStyleSwitch>(-1000001);
  }
};
}  // namespace WTF


namespace font_service {
namespace mojom {
namespace blink {
using TypefaceSlant = TypefaceSlant;  // Alias for definition in the parent namespace.
using RenderStyleSwitch = RenderStyleSwitch;  // Alias for definition in the parent namespace.
class FontService;
using FontServicePtr = mojo::InterfacePtr<FontService>;
using RevocableFontServicePtr = ::blink::RevocableInterfacePtr<FontService>;
using FontServicePtrInfo = mojo::InterfacePtrInfo<FontService>;
using ThreadSafeFontServicePtr =
    mojo::ThreadSafeInterfacePtr<FontService>;
using FontServiceRequest = mojo::InterfaceRequest<FontService>;
using FontServiceAssociatedPtr =
    mojo::AssociatedInterfacePtr<FontService>;
using ThreadSafeFontServiceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<FontService>;
using FontServiceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<FontService>;
using FontServiceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<FontService>;

class TypefaceStyle;
using TypefaceStylePtr = mojo::InlinedStructPtr<TypefaceStyle>;

class FontIdentity;
using FontIdentityPtr = mojo::InlinedStructPtr<FontIdentity>;

class FontRenderStyle;
using FontRenderStylePtr = mojo::StructPtr<FontRenderStyle>;


class FontServiceProxy;

template <typename ImplRefTraits>
class FontServiceStub;

class FontServiceRequestValidator;
class FontServiceResponseValidator;

class  FontService
    : public FontServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = FontServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = FontServiceStub<ImplRefTraits>;

  using RequestValidator_ = FontServiceRequestValidator;
  using ResponseValidator_ = FontServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kMatchFamilyNameMinVersion = 0,
    kOpenStreamMinVersion = 0,
    kFallbackFontForCharacterMinVersion = 0,
    kFontRenderStyleForStrikeMinVersion = 0,
    kMatchFontWithFallbackMinVersion = 0,
  };
  virtual ~FontService() {}


  using MatchFamilyNameCallback = base::OnceCallback<void(FontIdentityPtr, const WTF::String&, TypefaceStylePtr)>;
  virtual void MatchFamilyName(const WTF::String& family_name, TypefaceStylePtr style, MatchFamilyNameCallback callback) = 0;


  using OpenStreamCallback = base::OnceCallback<void(base::File)>;
  virtual void OpenStream(uint32_t id_number, OpenStreamCallback callback) = 0;


  using FallbackFontForCharacterCallback = base::OnceCallback<void(FontIdentityPtr, const WTF::String&, bool, bool)>;
  virtual void FallbackFontForCharacter(uint32_t character, const WTF::String& locale, FallbackFontForCharacterCallback callback) = 0;


  using FontRenderStyleForStrikeCallback = base::OnceCallback<void(FontRenderStylePtr)>;
  virtual void FontRenderStyleForStrike(const WTF::String& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStyleForStrikeCallback callback) = 0;


  using MatchFontWithFallbackCallback = base::OnceCallback<void(base::File)>;
  virtual void MatchFontWithFallback(const WTF::String& family, bool is_bold, bool is_italic, uint32_t charset, uint32_t fallback_family_type, MatchFontWithFallbackCallback callback) = 0;
};
class  FontServiceInterceptorForTesting : public FontService {
  virtual FontService* GetForwardingInterface() = 0;
  void MatchFamilyName(const WTF::String& family_name, TypefaceStylePtr style, MatchFamilyNameCallback callback) override;
  void OpenStream(uint32_t id_number, OpenStreamCallback callback) override;
  void FallbackFontForCharacter(uint32_t character, const WTF::String& locale, FallbackFontForCharacterCallback callback) override;
  void FontRenderStyleForStrike(const WTF::String& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStyleForStrikeCallback callback) override;
  void MatchFontWithFallback(const WTF::String& family, bool is_bold, bool is_italic, uint32_t charset, uint32_t fallback_family_type, MatchFontWithFallbackCallback callback) override;
};
class  FontServiceAsyncWaiter {
 public:
  explicit FontServiceAsyncWaiter(FontService* proxy);
  ~FontServiceAsyncWaiter();
  void MatchFamilyName(
      const WTF::String& family_name, TypefaceStylePtr style, FontIdentityPtr* out_identity, WTF::String* out_family_name, TypefaceStylePtr* out_style);
  void OpenStream(
      uint32_t id_number, base::File* out_font_handle);
  void FallbackFontForCharacter(
      uint32_t character, const WTF::String& locale, FontIdentityPtr* out_identity, WTF::String* out_family_name, bool* out_is_bold, bool* out_is_italic);
  void FontRenderStyleForStrike(
      const WTF::String& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStylePtr* out_font_render_style);
  void MatchFontWithFallback(
      const WTF::String& family, bool is_bold, bool is_italic, uint32_t charset, uint32_t fallback_family_type, base::File* out_font_file_handle);

 private:
  FontService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FontServiceAsyncWaiter);
};

class  FontServiceProxy
    : public FontService {
 public:
  explicit FontServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  void MatchFamilyName(const WTF::String& family_name, TypefaceStylePtr style, MatchFamilyNameCallback callback) final;
  void OpenStream(uint32_t id_number, OpenStreamCallback callback) final;
  void FallbackFontForCharacter(uint32_t character, const WTF::String& locale, FallbackFontForCharacterCallback callback) final;
  void FontRenderStyleForStrike(const WTF::String& family, uint32_t size, bool is_italic, bool is_bold, float device_scale_factor, FontRenderStyleForStrikeCallback callback) final;
  void MatchFontWithFallback(const WTF::String& family, bool is_bold, bool is_italic, uint32_t charset, uint32_t fallback_family_type, MatchFontWithFallbackCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  FontServiceStubDispatch {
 public:
  static bool Accept(FontService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FontService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FontService>>
class FontServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FontServiceStub() {}
  ~FontServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FontServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  FontServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  FontServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};


class  TypefaceStyle {
 public:
  using DataView = TypefaceStyleDataView;
  using Data_ = internal::TypefaceStyle_Data;

  template <typename... Args>
  static TypefaceStylePtr New(Args&&... args) {
    return TypefaceStylePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TypefaceStylePtr From(const U& u) {
    return mojo::TypeConverter<TypefaceStylePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TypefaceStyle>::Convert(*this);
  }


  TypefaceStyle();

  TypefaceStyle(
      uint16_t weight,
      uint8_t width,
      TypefaceSlant slant);

  ~TypefaceStyle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TypefaceStylePtr>
  TypefaceStylePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, TypefaceStyle>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TypefaceStyle::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TypefaceStyle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TypefaceStyle_UnserializedMessageContext<
            UserType, TypefaceStyle::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TypefaceStyle::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TypefaceStyle::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TypefaceStyle_UnserializedMessageContext<
            UserType, TypefaceStyle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TypefaceStyle::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  uint16_t weight;
  uint8_t width;
  TypefaceSlant slant;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


class  FontIdentity {
 public:
  using DataView = FontIdentityDataView;
  using Data_ = internal::FontIdentity_Data;

  template <typename... Args>
  static FontIdentityPtr New(Args&&... args) {
    return FontIdentityPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FontIdentityPtr From(const U& u) {
    return mojo::TypeConverter<FontIdentityPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FontIdentity>::Convert(*this);
  }


  FontIdentity();

  FontIdentity(
      uint32_t id,
      int32_t ttc_index,
      const WTF::String& str_representation);

  ~FontIdentity();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FontIdentityPtr>
  FontIdentityPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, FontIdentity>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FontIdentity::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FontIdentity::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FontIdentity_UnserializedMessageContext<
            UserType, FontIdentity::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FontIdentity::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FontIdentity::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FontIdentity_UnserializedMessageContext<
            UserType, FontIdentity::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FontIdentity::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  uint32_t id;
  int32_t ttc_index;
  WTF::String str_representation;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};







class  FontRenderStyle {
 public:
  using DataView = FontRenderStyleDataView;
  using Data_ = internal::FontRenderStyle_Data;

  template <typename... Args>
  static FontRenderStylePtr New(Args&&... args) {
    return FontRenderStylePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FontRenderStylePtr From(const U& u) {
    return mojo::TypeConverter<FontRenderStylePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FontRenderStyle>::Convert(*this);
  }


  FontRenderStyle();

  FontRenderStyle(
      RenderStyleSwitch use_bitmaps,
      RenderStyleSwitch use_autohint,
      RenderStyleSwitch use_hinting,
      uint8_t hint_style,
      RenderStyleSwitch use_antialias,
      RenderStyleSwitch use_subpixel_rendering,
      RenderStyleSwitch use_subpixel_positioning);

  ~FontRenderStyle();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FontRenderStylePtr>
  FontRenderStylePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, FontRenderStyle>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FontRenderStyle::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FontRenderStyle::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FontRenderStyle_UnserializedMessageContext<
            UserType, FontRenderStyle::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FontRenderStyle::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FontRenderStyle::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FontRenderStyle_UnserializedMessageContext<
            UserType, FontRenderStyle::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FontRenderStyle::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  RenderStyleSwitch use_bitmaps;
  RenderStyleSwitch use_autohint;
  RenderStyleSwitch use_hinting;
  uint8_t hint_style;
  RenderStyleSwitch use_antialias;
  RenderStyleSwitch use_subpixel_rendering;
  RenderStyleSwitch use_subpixel_positioning;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

template <typename StructPtrType>
TypefaceStylePtr TypefaceStyle::Clone() const {
  return New(
      mojo::Clone(weight),
      mojo::Clone(width),
      mojo::Clone(slant)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, TypefaceStyle>::value>::type*>
bool TypefaceStyle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->weight, other_struct.weight))
    return false;
  if (!mojo::Equals(this->width, other_struct.width))
    return false;
  if (!mojo::Equals(this->slant, other_struct.slant))
    return false;
  return true;
}
template <typename StructPtrType>
FontIdentityPtr FontIdentity::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(ttc_index),
      mojo::Clone(str_representation)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, FontIdentity>::value>::type*>
bool FontIdentity::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->ttc_index, other_struct.ttc_index))
    return false;
  if (!mojo::Equals(this->str_representation, other_struct.str_representation))
    return false;
  return true;
}
template <typename StructPtrType>
FontRenderStylePtr FontRenderStyle::Clone() const {
  return New(
      mojo::Clone(use_bitmaps),
      mojo::Clone(use_autohint),
      mojo::Clone(use_hinting),
      mojo::Clone(hint_style),
      mojo::Clone(use_antialias),
      mojo::Clone(use_subpixel_rendering),
      mojo::Clone(use_subpixel_positioning)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, FontRenderStyle>::value>::type*>
bool FontRenderStyle::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->use_bitmaps, other_struct.use_bitmaps))
    return false;
  if (!mojo::Equals(this->use_autohint, other_struct.use_autohint))
    return false;
  if (!mojo::Equals(this->use_hinting, other_struct.use_hinting))
    return false;
  if (!mojo::Equals(this->hint_style, other_struct.hint_style))
    return false;
  if (!mojo::Equals(this->use_antialias, other_struct.use_antialias))
    return false;
  if (!mojo::Equals(this->use_subpixel_rendering, other_struct.use_subpixel_rendering))
    return false;
  if (!mojo::Equals(this->use_subpixel_positioning, other_struct.use_subpixel_positioning))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace font_service

namespace mojo {


template <>
struct  StructTraits<::font_service::mojom::blink::TypefaceStyle::DataView,
                                         ::font_service::mojom::blink::TypefaceStylePtr> {
  static bool IsNull(const ::font_service::mojom::blink::TypefaceStylePtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::blink::TypefaceStylePtr* output) { output->reset(); }

  static decltype(::font_service::mojom::blink::TypefaceStyle::weight) weight(
      const ::font_service::mojom::blink::TypefaceStylePtr& input) {
    return input->weight;
  }

  static decltype(::font_service::mojom::blink::TypefaceStyle::width) width(
      const ::font_service::mojom::blink::TypefaceStylePtr& input) {
    return input->width;
  }

  static decltype(::font_service::mojom::blink::TypefaceStyle::slant) slant(
      const ::font_service::mojom::blink::TypefaceStylePtr& input) {
    return input->slant;
  }

  static bool Read(::font_service::mojom::blink::TypefaceStyle::DataView input, ::font_service::mojom::blink::TypefaceStylePtr* output);
};


template <>
struct  StructTraits<::font_service::mojom::blink::FontIdentity::DataView,
                                         ::font_service::mojom::blink::FontIdentityPtr> {
  static bool IsNull(const ::font_service::mojom::blink::FontIdentityPtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::blink::FontIdentityPtr* output) { output->reset(); }

  static decltype(::font_service::mojom::blink::FontIdentity::id) id(
      const ::font_service::mojom::blink::FontIdentityPtr& input) {
    return input->id;
  }

  static decltype(::font_service::mojom::blink::FontIdentity::ttc_index) ttc_index(
      const ::font_service::mojom::blink::FontIdentityPtr& input) {
    return input->ttc_index;
  }

  static const decltype(::font_service::mojom::blink::FontIdentity::str_representation)& str_representation(
      const ::font_service::mojom::blink::FontIdentityPtr& input) {
    return input->str_representation;
  }

  static bool Read(::font_service::mojom::blink::FontIdentity::DataView input, ::font_service::mojom::blink::FontIdentityPtr* output);
};


template <>
struct  StructTraits<::font_service::mojom::blink::FontRenderStyle::DataView,
                                         ::font_service::mojom::blink::FontRenderStylePtr> {
  static bool IsNull(const ::font_service::mojom::blink::FontRenderStylePtr& input) { return !input; }
  static void SetToNull(::font_service::mojom::blink::FontRenderStylePtr* output) { output->reset(); }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_bitmaps) use_bitmaps(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_bitmaps;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_autohint) use_autohint(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_autohint;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_hinting) use_hinting(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_hinting;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::hint_style) hint_style(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->hint_style;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_antialias) use_antialias(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_antialias;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_subpixel_rendering) use_subpixel_rendering(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_subpixel_rendering;
  }

  static decltype(::font_service::mojom::blink::FontRenderStyle::use_subpixel_positioning) use_subpixel_positioning(
      const ::font_service::mojom::blink::FontRenderStylePtr& input) {
    return input->use_subpixel_positioning;
  }

  static bool Read(::font_service::mojom::blink::FontRenderStyle::DataView input, ::font_service::mojom::blink::FontRenderStylePtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_FONT_PUBLIC_INTERFACES_FONT_SERVICE_MOJOM_BLINK_H_