// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  ProcessInternalsHandler_GetIsolationMode_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data));
      new (data()) ProcessInternalsHandler_GetIsolationMode_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolationMode_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolationMode_Params_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolationMode_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessInternalsHandler_GetIsolationMode_Params_Data();
  ~ProcessInternalsHandler_GetIsolationMode_Params_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data) == 8,
              "Bad sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data)");
class  ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data));
      new (data()) ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> mode;

 private:
  ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data();
  ~ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data)");
class  ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data));
      new (data()) ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data();
  ~ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data) == 8,
              "Bad sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data)");
class  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data));
      new (data()) ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t size;
  uint8_t padfinal_[4];

 private:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data();
  ~ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom

#endif  // CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_INTERNAL_H_