// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_H_
#define CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "content/browser/process_internals/process_internals.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace mojom {


}  // namespace mojom

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace mojom {
// Interface base classes. They are used for type safety check.
class ProcessInternalsHandlerInterfaceBase {};

using ProcessInternalsHandlerPtrDataView =
    mojo::InterfacePtrDataView<ProcessInternalsHandlerInterfaceBase>;
using ProcessInternalsHandlerRequestDataView =
    mojo::InterfaceRequestDataView<ProcessInternalsHandlerInterfaceBase>;
using ProcessInternalsHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ProcessInternalsHandlerInterfaceBase>;
using ProcessInternalsHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ProcessInternalsHandlerInterfaceBase>;
class ProcessInternalsHandler_GetIsolationMode_ParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolationMode_ParamsDataView() {}

  ProcessInternalsHandler_GetIsolationMode_ParamsDataView(
      internal::ProcessInternalsHandler_GetIsolationMode_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessInternalsHandler_GetIsolationMode_Params_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView() {}

  ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView(
      internal::ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetModeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMode(UserType* output) {
    auto* pointer = data_->mode.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView() {}

  ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView(
      internal::ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView() {}

  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView(
      internal::ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t size() const {
    return data_->size;
  }
 private:
  internal::ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data_ = nullptr;
};



}  // namespace mojom

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace mojom {



inline void ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView::GetModeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->mode.Get();
  *output = mojo::StringDataView(pointer, context_);
}







}  // namespace mojom

#endif  // CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_SHARED_H_
