// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_BLINK_H_
#define DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "device/vr/public/mojom/isolated_xr_service.mojom-shared.h"
#include "device/vr/public/mojom/vr_service.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace device {
namespace mojom {
namespace blink {
class XRSessionController;
using XRSessionControllerPtr = mojo::InterfacePtr<XRSessionController>;
using RevocableXRSessionControllerPtr = ::blink::RevocableInterfacePtr<XRSessionController>;
using XRSessionControllerPtrInfo = mojo::InterfacePtrInfo<XRSessionController>;
using ThreadSafeXRSessionControllerPtr =
    mojo::ThreadSafeInterfacePtr<XRSessionController>;
using XRSessionControllerRequest = mojo::InterfaceRequest<XRSessionController>;
using XRSessionControllerAssociatedPtr =
    mojo::AssociatedInterfacePtr<XRSessionController>;
using ThreadSafeXRSessionControllerAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<XRSessionController>;
using XRSessionControllerAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<XRSessionController>;
using XRSessionControllerAssociatedRequest =
    mojo::AssociatedInterfaceRequest<XRSessionController>;

class XRRuntimeEventListener;
using XRRuntimeEventListenerPtr = mojo::InterfacePtr<XRRuntimeEventListener>;
using RevocableXRRuntimeEventListenerPtr = ::blink::RevocableInterfacePtr<XRRuntimeEventListener>;
using XRRuntimeEventListenerPtrInfo = mojo::InterfacePtrInfo<XRRuntimeEventListener>;
using ThreadSafeXRRuntimeEventListenerPtr =
    mojo::ThreadSafeInterfacePtr<XRRuntimeEventListener>;
using XRRuntimeEventListenerRequest = mojo::InterfaceRequest<XRRuntimeEventListener>;
using XRRuntimeEventListenerAssociatedPtr =
    mojo::AssociatedInterfacePtr<XRRuntimeEventListener>;
using ThreadSafeXRRuntimeEventListenerAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<XRRuntimeEventListener>;
using XRRuntimeEventListenerAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<XRRuntimeEventListener>;
using XRRuntimeEventListenerAssociatedRequest =
    mojo::AssociatedInterfaceRequest<XRRuntimeEventListener>;

class XRRuntime;
using XRRuntimePtr = mojo::InterfacePtr<XRRuntime>;
using RevocableXRRuntimePtr = ::blink::RevocableInterfacePtr<XRRuntime>;
using XRRuntimePtrInfo = mojo::InterfacePtrInfo<XRRuntime>;
using ThreadSafeXRRuntimePtr =
    mojo::ThreadSafeInterfacePtr<XRRuntime>;
using XRRuntimeRequest = mojo::InterfaceRequest<XRRuntime>;
using XRRuntimeAssociatedPtr =
    mojo::AssociatedInterfacePtr<XRRuntime>;
using ThreadSafeXRRuntimeAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<XRRuntime>;
using XRRuntimeAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<XRRuntime>;
using XRRuntimeAssociatedRequest =
    mojo::AssociatedInterfaceRequest<XRRuntime>;

class XRDeviceRuntimeSessionOptions;
using XRDeviceRuntimeSessionOptionsPtr = mojo::StructPtr<XRDeviceRuntimeSessionOptions>;


class XRSessionControllerProxy;

template <typename ImplRefTraits>
class XRSessionControllerStub;

class XRSessionControllerRequestValidator;

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionController
    : public XRSessionControllerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = XRSessionControllerProxy;

  template <typename ImplRefTraits>
  using Stub_ = XRSessionControllerStub<ImplRefTraits>;

  using RequestValidator_ = XRSessionControllerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetFrameDataRestrictedMinVersion = 0,
  };
  virtual ~XRSessionController() {}

  virtual void SetFrameDataRestricted(bool restricted) = 0;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionControllerInterceptorForTesting : public XRSessionController {
  virtual XRSessionController* GetForwardingInterface() = 0;
  void SetFrameDataRestricted(bool restricted) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionControllerAsyncWaiter {
 public:
  explicit XRSessionControllerAsyncWaiter(XRSessionController* proxy);
  ~XRSessionControllerAsyncWaiter();

 private:
  XRSessionController* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(XRSessionControllerAsyncWaiter);
};

class XRRuntimeEventListenerProxy;

template <typename ImplRefTraits>
class XRRuntimeEventListenerStub;

class XRRuntimeEventListenerRequestValidator;
class XRRuntimeEventListenerResponseValidator;

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListener
    : public XRRuntimeEventListenerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = XRRuntimeEventListenerProxy;

  template <typename ImplRefTraits>
  using Stub_ = XRRuntimeEventListenerStub<ImplRefTraits>;

  using RequestValidator_ = XRRuntimeEventListenerRequestValidator;
  using ResponseValidator_ = XRRuntimeEventListenerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnDisplayInfoChangedMinVersion = 0,
    kOnDeviceActivatedMinVersion = 0,
    kOnDeviceIdleMinVersion = 0,
    kOnExitPresentMinVersion = 0,
  };
  virtual ~XRRuntimeEventListener() {}

  virtual void OnDisplayInfoChanged(::device::mojom::blink::VRDisplayInfoPtr display_info) = 0;


  using OnDeviceActivatedCallback = base::OnceCallback<void(bool)>;
  virtual void OnDeviceActivated(::device::mojom::blink::VRDisplayEventReason reason, OnDeviceActivatedCallback callback) = 0;

  virtual void OnDeviceIdle(::device::mojom::blink::VRDisplayEventReason reason) = 0;

  virtual void OnExitPresent() = 0;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerInterceptorForTesting : public XRRuntimeEventListener {
  virtual XRRuntimeEventListener* GetForwardingInterface() = 0;
  void OnDisplayInfoChanged(::device::mojom::blink::VRDisplayInfoPtr display_info) override;
  void OnDeviceActivated(::device::mojom::blink::VRDisplayEventReason reason, OnDeviceActivatedCallback callback) override;
  void OnDeviceIdle(::device::mojom::blink::VRDisplayEventReason reason) override;
  void OnExitPresent() override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerAsyncWaiter {
 public:
  explicit XRRuntimeEventListenerAsyncWaiter(XRRuntimeEventListener* proxy);
  ~XRRuntimeEventListenerAsyncWaiter();
  void OnDeviceActivated(
      ::device::mojom::blink::VRDisplayEventReason reason, bool* out_will_not_present);

 private:
  XRRuntimeEventListener* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(XRRuntimeEventListenerAsyncWaiter);
};

class XRRuntimeProxy;

template <typename ImplRefTraits>
class XRRuntimeStub;

class XRRuntimeRequestValidator;
class XRRuntimeResponseValidator;

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntime
    : public XRRuntimeInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = XRRuntimeProxy;

  template <typename ImplRefTraits>
  using Stub_ = XRRuntimeStub<ImplRefTraits>;

  using RequestValidator_ = XRRuntimeRequestValidator;
  using ResponseValidator_ = XRRuntimeResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestSessionMinVersion = 0,
    kRequestMagicWindowSessionMinVersion = 0,
    kListenToDeviceChangesMinVersion = 0,
    kSetListeningForActivateMinVersion = 0,
  };
  virtual ~XRRuntime() {}


  using RequestSessionCallback = base::OnceCallback<void(::device::mojom::blink::XRPresentationConnectionPtr, XRSessionControllerPtr)>;
  virtual void RequestSession(XRDeviceRuntimeSessionOptionsPtr options, RequestSessionCallback callback) = 0;


  using RequestMagicWindowSessionCallback = base::OnceCallback<void(::device::mojom::blink::VRMagicWindowProviderPtr, XRSessionControllerPtr)>;
  virtual void RequestMagicWindowSession(RequestMagicWindowSessionCallback callback) = 0;


  using ListenToDeviceChangesCallback = base::OnceCallback<void(::device::mojom::blink::VRDisplayInfoPtr)>;
  virtual void ListenToDeviceChanges(XRRuntimeEventListenerPtr listener, ListenToDeviceChangesCallback callback) = 0;

  virtual void SetListeningForActivate(bool listen_for_activation) = 0;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeInterceptorForTesting : public XRRuntime {
  virtual XRRuntime* GetForwardingInterface() = 0;
  void RequestSession(XRDeviceRuntimeSessionOptionsPtr options, RequestSessionCallback callback) override;
  void RequestMagicWindowSession(RequestMagicWindowSessionCallback callback) override;
  void ListenToDeviceChanges(XRRuntimeEventListenerPtr listener, ListenToDeviceChangesCallback callback) override;
  void SetListeningForActivate(bool listen_for_activation) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeAsyncWaiter {
 public:
  explicit XRRuntimeAsyncWaiter(XRRuntime* proxy);
  ~XRRuntimeAsyncWaiter();
  void RequestSession(
      XRDeviceRuntimeSessionOptionsPtr options, ::device::mojom::blink::XRPresentationConnectionPtr* out_connection, XRSessionControllerPtr* out_controller);
  void RequestMagicWindowSession(
      ::device::mojom::blink::VRMagicWindowProviderPtr* out_session, XRSessionControllerPtr* out_controller);
  void ListenToDeviceChanges(
      XRRuntimeEventListenerPtr listener, ::device::mojom::blink::VRDisplayInfoPtr* out_display_info);

 private:
  XRRuntime* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(XRRuntimeAsyncWaiter);
};

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionControllerProxy
    : public XRSessionController {
 public:
  explicit XRSessionControllerProxy(mojo::MessageReceiverWithResponder* receiver);
  void SetFrameDataRestricted(bool restricted) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerProxy
    : public XRRuntimeEventListener {
 public:
  explicit XRRuntimeEventListenerProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnDisplayInfoChanged(::device::mojom::blink::VRDisplayInfoPtr display_info) final;
  void OnDeviceActivated(::device::mojom::blink::VRDisplayEventReason reason, OnDeviceActivatedCallback callback) final;
  void OnDeviceIdle(::device::mojom::blink::VRDisplayEventReason reason) final;
  void OnExitPresent() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeProxy
    : public XRRuntime {
 public:
  explicit XRRuntimeProxy(mojo::MessageReceiverWithResponder* receiver);
  void RequestSession(XRDeviceRuntimeSessionOptionsPtr options, RequestSessionCallback callback) final;
  void RequestMagicWindowSession(RequestMagicWindowSessionCallback callback) final;
  void ListenToDeviceChanges(XRRuntimeEventListenerPtr listener, ListenToDeviceChangesCallback callback) final;
  void SetListeningForActivate(bool listen_for_activation) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionControllerStubDispatch {
 public:
  static bool Accept(XRSessionController* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      XRSessionController* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<XRSessionController>>
class XRSessionControllerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  XRSessionControllerStub() {}
  ~XRSessionControllerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRSessionControllerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRSessionControllerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerStubDispatch {
 public:
  static bool Accept(XRRuntimeEventListener* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      XRRuntimeEventListener* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<XRRuntimeEventListener>>
class XRRuntimeEventListenerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  XRRuntimeEventListenerStub() {}
  ~XRRuntimeEventListenerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRRuntimeEventListenerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRRuntimeEventListenerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeStubDispatch {
 public:
  static bool Accept(XRRuntime* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      XRRuntime* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<XRRuntime>>
class XRRuntimeStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  XRRuntimeStub() {}
  ~XRRuntimeStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRRuntimeStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return XRRuntimeStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRSessionControllerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeEventListenerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRRuntimeResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) XRDeviceRuntimeSessionOptions {
 public:
  using DataView = XRDeviceRuntimeSessionOptionsDataView;
  using Data_ = internal::XRDeviceRuntimeSessionOptions_Data;

  template <typename... Args>
  static XRDeviceRuntimeSessionOptionsPtr New(Args&&... args) {
    return XRDeviceRuntimeSessionOptionsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static XRDeviceRuntimeSessionOptionsPtr From(const U& u) {
    return mojo::TypeConverter<XRDeviceRuntimeSessionOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, XRDeviceRuntimeSessionOptions>::Convert(*this);
  }


  XRDeviceRuntimeSessionOptions();

  XRDeviceRuntimeSessionOptions(
      bool immersive,
      bool provide_passthrough_camera,
      int32_t render_process_id,
      int32_t render_frame_id,
      bool has_user_activation,
      bool use_legacy_webvr_render_path);

  ~XRDeviceRuntimeSessionOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = XRDeviceRuntimeSessionOptionsPtr>
  XRDeviceRuntimeSessionOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, XRDeviceRuntimeSessionOptions>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        XRDeviceRuntimeSessionOptions::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        XRDeviceRuntimeSessionOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::XRDeviceRuntimeSessionOptions_UnserializedMessageContext<
            UserType, XRDeviceRuntimeSessionOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<XRDeviceRuntimeSessionOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return XRDeviceRuntimeSessionOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::XRDeviceRuntimeSessionOptions_UnserializedMessageContext<
            UserType, XRDeviceRuntimeSessionOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<XRDeviceRuntimeSessionOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  bool immersive;
  bool provide_passthrough_camera;
  int32_t render_process_id;
  int32_t render_frame_id;
  bool has_user_activation;
  bool use_legacy_webvr_render_path;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

template <typename StructPtrType>
XRDeviceRuntimeSessionOptionsPtr XRDeviceRuntimeSessionOptions::Clone() const {
  return New(
      mojo::Clone(immersive),
      mojo::Clone(provide_passthrough_camera),
      mojo::Clone(render_process_id),
      mojo::Clone(render_frame_id),
      mojo::Clone(has_user_activation),
      mojo::Clone(use_legacy_webvr_render_path)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, XRDeviceRuntimeSessionOptions>::value>::type*>
bool XRDeviceRuntimeSessionOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->immersive, other_struct.immersive))
    return false;
  if (!mojo::Equals(this->provide_passthrough_camera, other_struct.provide_passthrough_camera))
    return false;
  if (!mojo::Equals(this->render_process_id, other_struct.render_process_id))
    return false;
  if (!mojo::Equals(this->render_frame_id, other_struct.render_frame_id))
    return false;
  if (!mojo::Equals(this->has_user_activation, other_struct.has_user_activation))
    return false;
  if (!mojo::Equals(this->use_legacy_webvr_render_path, other_struct.use_legacy_webvr_render_path))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace device

namespace mojo {


template <>
struct COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_BLINK) StructTraits<::device::mojom::blink::XRDeviceRuntimeSessionOptions::DataView,
                                         ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr> {
  static bool IsNull(const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) { return !input; }
  static void SetToNull(::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr* output) { output->reset(); }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::immersive) immersive(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->immersive;
  }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::provide_passthrough_camera) provide_passthrough_camera(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->provide_passthrough_camera;
  }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::render_process_id) render_process_id(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->render_process_id;
  }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::render_frame_id) render_frame_id(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->render_frame_id;
  }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::has_user_activation) has_user_activation(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->has_user_activation;
  }

  static decltype(::device::mojom::blink::XRDeviceRuntimeSessionOptions::use_legacy_webvr_render_path) use_legacy_webvr_render_path(
      const ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr& input) {
    return input->use_legacy_webvr_render_path;
  }

  static bool Read(::device::mojom::blink::XRDeviceRuntimeSessionOptions::DataView input, ::device::mojom::blink::XRDeviceRuntimeSessionOptionsPtr* output);
};

}  // namespace mojo

#endif  // DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_BLINK_H_