// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "device/vr/public/mojom/vr_service.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {
class XRDeviceRuntimeSessionOptions_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRDeviceRuntimeSessionOptions_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRDeviceRuntimeSessionOptions_Data));
      new (data()) XRDeviceRuntimeSessionOptions_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRDeviceRuntimeSessionOptions_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRDeviceRuntimeSessionOptions_Data>(index_);
    }
    XRDeviceRuntimeSessionOptions_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t immersive : 1;
  uint8_t provide_passthrough_camera : 1;
  uint8_t has_user_activation : 1;
  uint8_t use_legacy_webvr_render_path : 1;
  uint8_t pad3_[3];
  int32_t render_process_id;
  int32_t render_frame_id;
  uint8_t padfinal_[4];

 private:
  XRDeviceRuntimeSessionOptions_Data();
  ~XRDeviceRuntimeSessionOptions_Data() = delete;
};
static_assert(sizeof(XRDeviceRuntimeSessionOptions_Data) == 24,
              "Bad sizeof(XRDeviceRuntimeSessionOptions_Data)");
// Used by XRDeviceRuntimeSessionOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct XRDeviceRuntimeSessionOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  XRDeviceRuntimeSessionOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~XRDeviceRuntimeSessionOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    XRDeviceRuntimeSessionOptions_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    XRDeviceRuntimeSessionOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRSessionController_SetFrameDataRestricted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRSessionController_SetFrameDataRestricted_Params_Data));
      new (data()) XRSessionController_SetFrameDataRestricted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRSessionController_SetFrameDataRestricted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRSessionController_SetFrameDataRestricted_Params_Data>(index_);
    }
    XRSessionController_SetFrameDataRestricted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t restricted : 1;
  uint8_t padfinal_[7];

 private:
  XRSessionController_SetFrameDataRestricted_Params_Data();
  ~XRSessionController_SetFrameDataRestricted_Params_Data() = delete;
};
static_assert(sizeof(XRSessionController_SetFrameDataRestricted_Params_Data) == 16,
              "Bad sizeof(XRSessionController_SetFrameDataRestricted_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data));
      new (data()) XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::VRDisplayInfo_Data> display_info;

 private:
  XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data();
  ~XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceActivated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data));
      new (data()) XRRuntimeEventListener_OnDeviceActivated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceActivated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceActivated_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceActivated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  XRRuntimeEventListener_OnDeviceActivated_Params_Data();
  ~XRRuntimeEventListener_OnDeviceActivated_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceActivated_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data));
      new (data()) XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t will_not_present : 1;
  uint8_t padfinal_[7];

 private:
  XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data();
  ~XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnDeviceIdle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data));
      new (data()) XRRuntimeEventListener_OnDeviceIdle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnDeviceIdle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnDeviceIdle_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnDeviceIdle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  XRRuntimeEventListener_OnDeviceIdle_Params_Data();
  ~XRRuntimeEventListener_OnDeviceIdle_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data) == 16,
              "Bad sizeof(XRRuntimeEventListener_OnDeviceIdle_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntimeEventListener_OnExitPresent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data));
      new (data()) XRRuntimeEventListener_OnExitPresent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntimeEventListener_OnExitPresent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntimeEventListener_OnExitPresent_Params_Data>(index_);
    }
    XRRuntimeEventListener_OnExitPresent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  XRRuntimeEventListener_OnExitPresent_Params_Data();
  ~XRRuntimeEventListener_OnExitPresent_Params_Data() = delete;
};
static_assert(sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data) == 8,
              "Bad sizeof(XRRuntimeEventListener_OnExitPresent_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestSession_Params_Data));
      new (data()) XRRuntime_RequestSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestSession_Params_Data>(index_);
    }
    XRRuntime_RequestSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::XRDeviceRuntimeSessionOptions_Data> options;

 private:
  XRRuntime_RequestSession_Params_Data();
  ~XRRuntime_RequestSession_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestSession_Params_Data) == 16,
              "Bad sizeof(XRRuntime_RequestSession_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestSession_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestSession_ResponseParams_Data));
      new (data()) XRRuntime_RequestSession_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestSession_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestSession_ResponseParams_Data>(index_);
    }
    XRRuntime_RequestSession_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::XRPresentationConnection_Data> connection;
  mojo::internal::Interface_Data controller;

 private:
  XRRuntime_RequestSession_ResponseParams_Data();
  ~XRRuntime_RequestSession_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestSession_ResponseParams_Data) == 24,
              "Bad sizeof(XRRuntime_RequestSession_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestMagicWindowSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestMagicWindowSession_Params_Data));
      new (data()) XRRuntime_RequestMagicWindowSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestMagicWindowSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestMagicWindowSession_Params_Data>(index_);
    }
    XRRuntime_RequestMagicWindowSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  XRRuntime_RequestMagicWindowSession_Params_Data();
  ~XRRuntime_RequestMagicWindowSession_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestMagicWindowSession_Params_Data) == 8,
              "Bad sizeof(XRRuntime_RequestMagicWindowSession_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_RequestMagicWindowSession_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_RequestMagicWindowSession_ResponseParams_Data));
      new (data()) XRRuntime_RequestMagicWindowSession_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_RequestMagicWindowSession_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_RequestMagicWindowSession_ResponseParams_Data>(index_);
    }
    XRRuntime_RequestMagicWindowSession_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data session;
  mojo::internal::Interface_Data controller;

 private:
  XRRuntime_RequestMagicWindowSession_ResponseParams_Data();
  ~XRRuntime_RequestMagicWindowSession_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_RequestMagicWindowSession_ResponseParams_Data) == 24,
              "Bad sizeof(XRRuntime_RequestMagicWindowSession_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_ListenToDeviceChanges_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_ListenToDeviceChanges_Params_Data));
      new (data()) XRRuntime_ListenToDeviceChanges_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_ListenToDeviceChanges_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_ListenToDeviceChanges_Params_Data>(index_);
    }
    XRRuntime_ListenToDeviceChanges_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data listener;

 private:
  XRRuntime_ListenToDeviceChanges_Params_Data();
  ~XRRuntime_ListenToDeviceChanges_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_ListenToDeviceChanges_Params_Data) == 16,
              "Bad sizeof(XRRuntime_ListenToDeviceChanges_Params_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_ListenToDeviceChanges_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data));
      new (data()) XRRuntime_ListenToDeviceChanges_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_ListenToDeviceChanges_ResponseParams_Data>(index_);
    }
    XRRuntime_ListenToDeviceChanges_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::device::mojom::internal::VRDisplayInfo_Data> display_info;

 private:
  XRRuntime_ListenToDeviceChanges_ResponseParams_Data();
  ~XRRuntime_ListenToDeviceChanges_ResponseParams_Data() = delete;
};
static_assert(sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data) == 16,
              "Bad sizeof(XRRuntime_ListenToDeviceChanges_ResponseParams_Data)");
class COMPONENT_EXPORT(DEVICE_VR_MOJO_BINDINGS_SHARED) XRRuntime_SetListeningForActivate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(XRRuntime_SetListeningForActivate_Params_Data));
      new (data()) XRRuntime_SetListeningForActivate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    XRRuntime_SetListeningForActivate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<XRRuntime_SetListeningForActivate_Params_Data>(index_);
    }
    XRRuntime_SetListeningForActivate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t listen_for_activation : 1;
  uint8_t padfinal_[7];

 private:
  XRRuntime_SetListeningForActivate_Params_Data();
  ~XRRuntime_SetListeningForActivate_Params_Data() = delete;
};
static_assert(sizeof(XRRuntime_SetListeningForActivate_Params_Data) == 16,
              "Bad sizeof(XRRuntime_SetListeningForActivate_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_INTERNAL_H_