// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_
#define DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "device/vr/public/mojom/isolated_xr_service.mojom-shared-internal.h"
#include "device/vr/public/mojom/vr_service.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace device {
namespace mojom {
class XRDeviceRuntimeSessionOptionsDataView;



}  // namespace mojom
}  // namespace device

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::device::mojom::XRDeviceRuntimeSessionOptionsDataView> {
  using Data = ::device::mojom::internal::XRDeviceRuntimeSessionOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace device {
namespace mojom {
// Interface base classes. They are used for type safety check.
class XRSessionControllerInterfaceBase {};

using XRSessionControllerPtrDataView =
    mojo::InterfacePtrDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerRequestDataView =
    mojo::InterfaceRequestDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRSessionControllerInterfaceBase>;
using XRSessionControllerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRSessionControllerInterfaceBase>;
class XRRuntimeEventListenerInterfaceBase {};

using XRRuntimeEventListenerPtrDataView =
    mojo::InterfacePtrDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerRequestDataView =
    mojo::InterfaceRequestDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRRuntimeEventListenerInterfaceBase>;
using XRRuntimeEventListenerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRRuntimeEventListenerInterfaceBase>;
class XRRuntimeInterfaceBase {};

using XRRuntimePtrDataView =
    mojo::InterfacePtrDataView<XRRuntimeInterfaceBase>;
using XRRuntimeRequestDataView =
    mojo::InterfaceRequestDataView<XRRuntimeInterfaceBase>;
using XRRuntimeAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<XRRuntimeInterfaceBase>;
using XRRuntimeAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<XRRuntimeInterfaceBase>;
class XRDeviceRuntimeSessionOptionsDataView {
 public:
  XRDeviceRuntimeSessionOptionsDataView() {}

  XRDeviceRuntimeSessionOptionsDataView(
      internal::XRDeviceRuntimeSessionOptions_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool immersive() const {
    return data_->immersive;
  }
  bool provide_passthrough_camera() const {
    return data_->provide_passthrough_camera;
  }
  int32_t render_process_id() const {
    return data_->render_process_id;
  }
  int32_t render_frame_id() const {
    return data_->render_frame_id;
  }
  bool has_user_activation() const {
    return data_->has_user_activation;
  }
  bool use_legacy_webvr_render_path() const {
    return data_->use_legacy_webvr_render_path;
  }
 private:
  internal::XRDeviceRuntimeSessionOptions_Data* data_ = nullptr;
};

class XRSessionController_SetFrameDataRestricted_ParamsDataView {
 public:
  XRSessionController_SetFrameDataRestricted_ParamsDataView() {}

  XRSessionController_SetFrameDataRestricted_ParamsDataView(
      internal::XRSessionController_SetFrameDataRestricted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool restricted() const {
    return data_->restricted;
  }
 private:
  internal::XRSessionController_SetFrameDataRestricted_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView() {}

  XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView(
      internal::XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplayInfoDataView(
      ::device::mojom::VRDisplayInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplayInfo(UserType* output) {
    auto* pointer = data_->display_info.Get();
    return mojo::internal::Deserialize<::device::mojom::VRDisplayInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntimeEventListener_OnDisplayInfoChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceActivated_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceActivated_ParamsDataView() {}

  XRRuntimeEventListener_OnDeviceActivated_ParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceActivated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReason(UserType* output) const {
    auto data_value = data_->reason;
    return mojo::internal::Deserialize<::device::mojom::VRDisplayEventReason>(
        data_value, output);
  }

  ::device::mojom::VRDisplayEventReason reason() const {
    return static_cast<::device::mojom::VRDisplayEventReason>(data_->reason);
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceActivated_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView() {}

  XRRuntimeEventListener_OnDeviceActivated_ResponseParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool will_not_present() const {
    return data_->will_not_present;
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceActivated_ResponseParams_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnDeviceIdle_ParamsDataView {
 public:
  XRRuntimeEventListener_OnDeviceIdle_ParamsDataView() {}

  XRRuntimeEventListener_OnDeviceIdle_ParamsDataView(
      internal::XRRuntimeEventListener_OnDeviceIdle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReason(UserType* output) const {
    auto data_value = data_->reason;
    return mojo::internal::Deserialize<::device::mojom::VRDisplayEventReason>(
        data_value, output);
  }

  ::device::mojom::VRDisplayEventReason reason() const {
    return static_cast<::device::mojom::VRDisplayEventReason>(data_->reason);
  }
 private:
  internal::XRRuntimeEventListener_OnDeviceIdle_Params_Data* data_ = nullptr;
};

class XRRuntimeEventListener_OnExitPresent_ParamsDataView {
 public:
  XRRuntimeEventListener_OnExitPresent_ParamsDataView() {}

  XRRuntimeEventListener_OnExitPresent_ParamsDataView(
      internal::XRRuntimeEventListener_OnExitPresent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::XRRuntimeEventListener_OnExitPresent_Params_Data* data_ = nullptr;
};

class XRRuntime_RequestSession_ParamsDataView {
 public:
  XRRuntime_RequestSession_ParamsDataView() {}

  XRRuntime_RequestSession_ParamsDataView(
      internal::XRRuntime_RequestSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOptionsDataView(
      XRDeviceRuntimeSessionOptionsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOptions(UserType* output) {
    auto* pointer = data_->options.Get();
    return mojo::internal::Deserialize<::device::mojom::XRDeviceRuntimeSessionOptionsDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntime_RequestSession_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_RequestSession_ResponseParamsDataView {
 public:
  XRRuntime_RequestSession_ResponseParamsDataView() {}

  XRRuntime_RequestSession_ResponseParamsDataView(
      internal::XRRuntime_RequestSession_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetConnectionDataView(
      ::device::mojom::XRPresentationConnectionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConnection(UserType* output) {
    auto* pointer = data_->connection.Get();
    return mojo::internal::Deserialize<::device::mojom::XRPresentationConnectionDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeController() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRSessionControllerPtrDataView>(
            &data_->controller, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRRuntime_RequestSession_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_RequestMagicWindowSession_ParamsDataView {
 public:
  XRRuntime_RequestMagicWindowSession_ParamsDataView() {}

  XRRuntime_RequestMagicWindowSession_ParamsDataView(
      internal::XRRuntime_RequestMagicWindowSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::XRRuntime_RequestMagicWindowSession_Params_Data* data_ = nullptr;
};

class XRRuntime_RequestMagicWindowSession_ResponseParamsDataView {
 public:
  XRRuntime_RequestMagicWindowSession_ResponseParamsDataView() {}

  XRRuntime_RequestMagicWindowSession_ResponseParamsDataView(
      internal::XRRuntime_RequestMagicWindowSession_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::VRMagicWindowProviderPtrDataView>(
            &data_->session, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeController() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRSessionControllerPtrDataView>(
            &data_->controller, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRRuntime_RequestMagicWindowSession_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_ListenToDeviceChanges_ParamsDataView {
 public:
  XRRuntime_ListenToDeviceChanges_ParamsDataView() {}

  XRRuntime_ListenToDeviceChanges_ParamsDataView(
      internal::XRRuntime_ListenToDeviceChanges_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeListener() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::XRRuntimeEventListenerPtrDataView>(
            &data_->listener, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::XRRuntime_ListenToDeviceChanges_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_ListenToDeviceChanges_ResponseParamsDataView {
 public:
  XRRuntime_ListenToDeviceChanges_ResponseParamsDataView() {}

  XRRuntime_ListenToDeviceChanges_ResponseParamsDataView(
      internal::XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplayInfoDataView(
      ::device::mojom::VRDisplayInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplayInfo(UserType* output) {
    auto* pointer = data_->display_info.Get();
    return mojo::internal::Deserialize<::device::mojom::VRDisplayInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::XRRuntime_ListenToDeviceChanges_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class XRRuntime_SetListeningForActivate_ParamsDataView {
 public:
  XRRuntime_SetListeningForActivate_ParamsDataView() {}

  XRRuntime_SetListeningForActivate_ParamsDataView(
      internal::XRRuntime_SetListeningForActivate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool listen_for_activation() const {
    return data_->listen_for_activation;
  }
 private:
  internal::XRRuntime_SetListeningForActivate_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace device

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::XRDeviceRuntimeSessionOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::XRDeviceRuntimeSessionOptionsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::device::mojom::internal::XRDeviceRuntimeSessionOptions_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->immersive = CallWithContext(Traits::immersive, input, custom_context);
    (*output)->provide_passthrough_camera = CallWithContext(Traits::provide_passthrough_camera, input, custom_context);
    (*output)->render_process_id = CallWithContext(Traits::render_process_id, input, custom_context);
    (*output)->render_frame_id = CallWithContext(Traits::render_frame_id, input, custom_context);
    (*output)->has_user_activation = CallWithContext(Traits::has_user_activation, input, custom_context);
    (*output)->use_legacy_webvr_render_path = CallWithContext(Traits::use_legacy_webvr_render_path, input, custom_context);
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::device::mojom::internal::XRDeviceRuntimeSessionOptions_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::XRDeviceRuntimeSessionOptionsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace device {
namespace mojom {





inline void XRRuntimeEventListener_OnDisplayInfoChanged_ParamsDataView::GetDisplayInfoDataView(
    ::device::mojom::VRDisplayInfoDataView* output) {
  auto pointer = data_->display_info.Get();
  *output = ::device::mojom::VRDisplayInfoDataView(pointer, context_);
}










inline void XRRuntime_RequestSession_ParamsDataView::GetOptionsDataView(
    XRDeviceRuntimeSessionOptionsDataView* output) {
  auto pointer = data_->options.Get();
  *output = XRDeviceRuntimeSessionOptionsDataView(pointer, context_);
}


inline void XRRuntime_RequestSession_ResponseParamsDataView::GetConnectionDataView(
    ::device::mojom::XRPresentationConnectionDataView* output) {
  auto pointer = data_->connection.Get();
  *output = ::device::mojom::XRPresentationConnectionDataView(pointer, context_);
}








inline void XRRuntime_ListenToDeviceChanges_ResponseParamsDataView::GetDisplayInfoDataView(
    ::device::mojom::VRDisplayInfoDataView* output) {
  auto pointer = data_->display_info.Get();
  *output = ::device::mojom::VRDisplayInfoDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace device

#endif  // DEVICE_VR_PUBLIC_MOJOM_ISOLATED_XR_SERVICE_MOJOM_SHARED_H_
