// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_AUDIO_PUBLIC_MOJOM_LOG_FACTORY_MANAGER_MOJOM_SHARED_H_
#define SERVICES_AUDIO_PUBLIC_MOJOM_LOG_FACTORY_MANAGER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/audio/public/mojom/log_factory_manager.mojom-shared-internal.h"
#include "media/mojo/interfaces/audio_logging.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace audio {
namespace mojom {


}  // namespace mojom
}  // namespace audio

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace audio {
namespace mojom {
// Interface base classes. They are used for type safety check.
class LogFactoryManagerInterfaceBase {};

using LogFactoryManagerPtrDataView =
    mojo::InterfacePtrDataView<LogFactoryManagerInterfaceBase>;
using LogFactoryManagerRequestDataView =
    mojo::InterfaceRequestDataView<LogFactoryManagerInterfaceBase>;
using LogFactoryManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LogFactoryManagerInterfaceBase>;
using LogFactoryManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LogFactoryManagerInterfaceBase>;
class LogFactoryManager_SetLogFactory_ParamsDataView {
 public:
  LogFactoryManager_SetLogFactory_ParamsDataView() {}

  LogFactoryManager_SetLogFactory_ParamsDataView(
      internal::LogFactoryManager_SetLogFactory_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeFactory() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::media::mojom::AudioLogFactoryPtrDataView>(
            &data_->factory, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::LogFactoryManager_SetLogFactory_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace audio

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace audio {
namespace mojom {




}  // namespace mojom
}  // namespace audio

#endif  // SERVICES_AUDIO_PUBLIC_MOJOM_LOG_FACTORY_MANAGER_MOJOM_SHARED_H_
