// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_H_
#define SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/audio/public/mojom/testing_api.mojom-shared.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace audio {
namespace mojom {
class TestingApi;
using TestingApiPtr = mojo::InterfacePtr<TestingApi>;
using TestingApiPtrInfo = mojo::InterfacePtrInfo<TestingApi>;
using ThreadSafeTestingApiPtr =
    mojo::ThreadSafeInterfacePtr<TestingApi>;
using TestingApiRequest = mojo::InterfaceRequest<TestingApi>;
using TestingApiAssociatedPtr =
    mojo::AssociatedInterfacePtr<TestingApi>;
using ThreadSafeTestingApiAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<TestingApi>;
using TestingApiAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<TestingApi>;
using TestingApiAssociatedRequest =
    mojo::AssociatedInterfaceRequest<TestingApi>;


class TestingApiProxy;

template <typename ImplRefTraits>
class TestingApiStub;

class TestingApiRequestValidator;

class  TestingApi
    : public TestingApiInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = TestingApiProxy;

  template <typename ImplRefTraits>
  using Stub_ = TestingApiStub<ImplRefTraits>;

  using RequestValidator_ = TestingApiRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCrashMinVersion = 0,
  };
  virtual ~TestingApi() {}

  virtual void Crash() = 0;
};
class  TestingApiInterceptorForTesting : public TestingApi {
  virtual TestingApi* GetForwardingInterface() = 0;
  void Crash() override;
};
class  TestingApiAsyncWaiter {
 public:
  explicit TestingApiAsyncWaiter(TestingApi* proxy);
  ~TestingApiAsyncWaiter();

 private:
  TestingApi* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(TestingApiAsyncWaiter);
};

class  TestingApiProxy
    : public TestingApi {
 public:
  explicit TestingApiProxy(mojo::MessageReceiverWithResponder* receiver);
  void Crash() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  TestingApiStubDispatch {
 public:
  static bool Accept(TestingApi* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TestingApi* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TestingApi>>
class TestingApiStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TestingApiStub() {}
  ~TestingApiStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TestingApiStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TestingApiStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  TestingApiRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace audio

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_H_