// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_H_
#define SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/content/public/mojom/navigable_contents.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace content {
namespace mojom {


}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class NavigableContentsInterfaceBase {};

using NavigableContentsPtrDataView =
    mojo::InterfacePtrDataView<NavigableContentsInterfaceBase>;
using NavigableContentsRequestDataView =
    mojo::InterfaceRequestDataView<NavigableContentsInterfaceBase>;
using NavigableContentsAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NavigableContentsInterfaceBase>;
using NavigableContentsAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NavigableContentsInterfaceBase>;
class NavigableContentsClientInterfaceBase {};

using NavigableContentsClientPtrDataView =
    mojo::InterfacePtrDataView<NavigableContentsClientInterfaceBase>;
using NavigableContentsClientRequestDataView =
    mojo::InterfaceRequestDataView<NavigableContentsClientInterfaceBase>;
using NavigableContentsClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NavigableContentsClientInterfaceBase>;
using NavigableContentsClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NavigableContentsClientInterfaceBase>;
class NavigableContents_Navigate_ParamsDataView {
 public:
  NavigableContents_Navigate_ParamsDataView() {}

  NavigableContents_Navigate_ParamsDataView(
      internal::NavigableContents_Navigate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::NavigableContents_Navigate_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NavigableContents_CreateView_ParamsDataView {
 public:
  NavigableContents_CreateView_ParamsDataView() {}

  NavigableContents_CreateView_ParamsDataView(
      internal::NavigableContents_CreateView_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NavigableContents_CreateView_Params_Data* data_ = nullptr;
};

class NavigableContents_CreateView_ResponseParamsDataView {
 public:
  NavigableContents_CreateView_ResponseParamsDataView() {}

  NavigableContents_CreateView_ResponseParamsDataView(
      internal::NavigableContents_CreateView_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetEmbedTokenDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEmbedToken(UserType* output) {
    auto* pointer = data_->embed_token.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, context_);
  }
 private:
  internal::NavigableContents_CreateView_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NavigableContentsClient_DidStopLoading_ParamsDataView {
 public:
  NavigableContentsClient_DidStopLoading_ParamsDataView() {}

  NavigableContentsClient_DidStopLoading_ParamsDataView(
      internal::NavigableContentsClient_DidStopLoading_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NavigableContentsClient_DidStopLoading_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace content {
namespace mojom {

inline void NavigableContents_Navigate_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}




inline void NavigableContents_CreateView_ResponseParamsDataView::GetEmbedTokenDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->embed_token.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace content

#endif  // SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_MOJOM_SHARED_H_
