// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/content/public/mojom/navigable_contents.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
class NavigableContentsParams_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsParams_Data));
      new (data()) NavigableContentsParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsParams_Data>(index_);
    }
    NavigableContentsParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NavigableContentsParams_Data();
  ~NavigableContentsParams_Data() = delete;
};
static_assert(sizeof(NavigableContentsParams_Data) == 8,
              "Bad sizeof(NavigableContentsParams_Data)");
// Used by NavigableContentsParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct NavigableContentsParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  NavigableContentsParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~NavigableContentsParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    NavigableContentsParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    NavigableContentsParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM_SHARED) NavigableContentsFactory_CreateContents_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NavigableContentsFactory_CreateContents_Params_Data));
      new (data()) NavigableContentsFactory_CreateContents_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NavigableContentsFactory_CreateContents_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NavigableContentsFactory_CreateContents_Params_Data>(index_);
    }
    NavigableContentsFactory_CreateContents_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::NavigableContentsParams_Data> params;
  mojo::internal::Handle_Data request;
  mojo::internal::Interface_Data client;
  uint8_t padfinal_[4];

 private:
  NavigableContentsFactory_CreateContents_Params_Data();
  ~NavigableContentsFactory_CreateContents_Params_Data() = delete;
};
static_assert(sizeof(NavigableContentsFactory_CreateContents_Params_Data) == 32,
              "Bad sizeof(NavigableContentsFactory_CreateContents_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_SHARED_INTERNAL_H_