// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/content/public/mojom/navigable_contents_factory.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/content/public/mojom/navigable_contents_factory.mojom-shared-message-ids.h"
namespace content {
namespace mojom {
NavigableContentsParams::NavigableContentsParams() {}

NavigableContentsParams::~NavigableContentsParams() = default;
size_t NavigableContentsParams::Hash(size_t seed) const {
  return seed;
}

bool NavigableContentsParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char NavigableContentsFactory::Name_[] = "content.mojom.NavigableContentsFactory";

NavigableContentsFactoryProxy::NavigableContentsFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void NavigableContentsFactoryProxy::CreateContents(
    NavigableContentsParamsPtr in_params, ::content::mojom::NavigableContentsRequest in_request, ::content::mojom::NavigableContentsClientPtr in_client) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "content::mojom::NavigableContentsFactory::CreateContents");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kNavigableContentsFactory_CreateContents_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::content::mojom::internal::NavigableContentsFactory_CreateContents_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->params)::BaseType::BufferWriter
      params_writer;
  mojo::internal::Serialize<::content::mojom::NavigableContentsParamsDataView>(
      in_params, buffer, &params_writer, &serialization_context);
  params->params.Set(
      params_writer.is_null() ? nullptr : params_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->params.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null params in NavigableContentsFactory.CreateContents request");
  mojo::internal::Serialize<::content::mojom::NavigableContentsRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in NavigableContentsFactory.CreateContents request");
  mojo::internal::Serialize<::content::mojom::NavigableContentsClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in NavigableContentsFactory.CreateContents request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NavigableContentsFactory::Name_);
  message.set_method_name("CreateContents");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool NavigableContentsFactoryStubDispatch::Accept(
    NavigableContentsFactory* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kNavigableContentsFactory_CreateContents_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)content::mojom::NavigableContentsFactory::CreateContents",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::NavigableContentsFactory_CreateContents_Params_Data* params =
          reinterpret_cast<internal::NavigableContentsFactory_CreateContents_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      NavigableContentsParamsPtr p_params{};
      ::content::mojom::NavigableContentsRequest p_request{};
      ::content::mojom::NavigableContentsClientPtr p_client{};
      NavigableContentsFactory_CreateContents_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadParams(&p_params))
        success = false;
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "NavigableContentsFactory::CreateContents deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateContents(
std::move(p_params), 
std::move(p_request), 
std::move(p_client));
      return true;
    }
  }
  return false;
}

// static
bool NavigableContentsFactoryStubDispatch::AcceptWithResponder(
    NavigableContentsFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kNavigableContentsFactory_CreateContents_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)content::mojom::NavigableContentsFactory::CreateContents",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool NavigableContentsFactoryRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "NavigableContentsFactory RequestValidator");

  switch (message->header()->name) {
    case internal::kNavigableContentsFactory_CreateContents_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::NavigableContentsFactory_CreateContents_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void NavigableContentsFactoryInterceptorForTesting::CreateContents(NavigableContentsParamsPtr params, ::content::mojom::NavigableContentsRequest request, ::content::mojom::NavigableContentsClientPtr client) {
  GetForwardingInterface()->CreateContents(std::move(params), std::move(request), std::move(client));
}
NavigableContentsFactoryAsyncWaiter::NavigableContentsFactoryAsyncWaiter(
    NavigableContentsFactory* proxy) : proxy_(proxy) {}

NavigableContentsFactoryAsyncWaiter::~NavigableContentsFactoryAsyncWaiter() = default;


}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::NavigableContentsParams::DataView, ::content::mojom::NavigableContentsParamsPtr>::Read(
    ::content::mojom::NavigableContentsParams::DataView input,
    ::content::mojom::NavigableContentsParamsPtr* output) {
  bool success = true;
  ::content::mojom::NavigableContentsParamsPtr result(::content::mojom::NavigableContentsParams::New());
  
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif