// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_SHARED_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/viz/public/interfaces/compositing/compositing_mode_watcher.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace viz {
namespace mojom {


}  // namespace mojom
}  // namespace viz

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace viz {
namespace mojom {
// Interface base classes. They are used for type safety check.
class CompositingModeWatcherInterfaceBase {};

using CompositingModeWatcherPtrDataView =
    mojo::InterfacePtrDataView<CompositingModeWatcherInterfaceBase>;
using CompositingModeWatcherRequestDataView =
    mojo::InterfaceRequestDataView<CompositingModeWatcherInterfaceBase>;
using CompositingModeWatcherAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<CompositingModeWatcherInterfaceBase>;
using CompositingModeWatcherAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<CompositingModeWatcherInterfaceBase>;
class CompositingModeReporterInterfaceBase {};

using CompositingModeReporterPtrDataView =
    mojo::InterfacePtrDataView<CompositingModeReporterInterfaceBase>;
using CompositingModeReporterRequestDataView =
    mojo::InterfaceRequestDataView<CompositingModeReporterInterfaceBase>;
using CompositingModeReporterAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<CompositingModeReporterInterfaceBase>;
using CompositingModeReporterAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<CompositingModeReporterInterfaceBase>;
class CompositingModeWatcher_CompositingModeFallbackToSoftware_ParamsDataView {
 public:
  CompositingModeWatcher_CompositingModeFallbackToSoftware_ParamsDataView() {}

  CompositingModeWatcher_CompositingModeFallbackToSoftware_ParamsDataView(
      internal::CompositingModeWatcher_CompositingModeFallbackToSoftware_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::CompositingModeWatcher_CompositingModeFallbackToSoftware_Params_Data* data_ = nullptr;
};

class CompositingModeReporter_AddCompositingModeWatcher_ParamsDataView {
 public:
  CompositingModeReporter_AddCompositingModeWatcher_ParamsDataView() {}

  CompositingModeReporter_AddCompositingModeWatcher_ParamsDataView(
      internal::CompositingModeReporter_AddCompositingModeWatcher_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeWatcher() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::viz::mojom::CompositingModeWatcherPtrDataView>(
            &data_->watcher, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::CompositingModeReporter_AddCompositingModeWatcher_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace viz

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace viz {
namespace mojom {






}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITING_MODE_WATCHER_MOJOM_SHARED_H_
