// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/viz/public/interfaces/compositing/returned_resource.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/viz/public/interfaces/compositing/returned_resource.mojom-shared-message-ids.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
namespace viz {
namespace mojom {
namespace blink {
ReturnedResource::ReturnedResource()
    : id(),
      sync_token(),
      count(),
      lost() {}

ReturnedResource::ReturnedResource(
    uint32_t id_in,
    const ::gpu::SyncToken& sync_token_in,
    int32_t count_in,
    bool lost_in)
    : id(std::move(id_in)),
      sync_token(std::move(sync_token_in)),
      count(std::move(count_in)),
      lost(std::move(lost_in)) {}

ReturnedResource::~ReturnedResource() = default;

bool ReturnedResource::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace viz

namespace mojo {


// static
bool StructTraits<::viz::mojom::blink::ReturnedResource::DataView, ::viz::mojom::blink::ReturnedResourcePtr>::Read(
    ::viz::mojom::blink::ReturnedResource::DataView input,
    ::viz::mojom::blink::ReturnedResourcePtr* output) {
  bool success = true;
  ::viz::mojom::blink::ReturnedResourcePtr result(::viz::mojom::blink::ReturnedResource::New());
  
      result->id = input.id();
      if (!input.ReadSyncToken(&result->sync_token))
        success = false;
      result->count = input.count();
      result->lost = input.lost();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif